import React, { useEffect, useState } from 'react'
import ReactHtmlParser  from 'react-html-parser'
import {
    // Tree,
    Table,
    Space,
    Input,
    Button,
    Select,
    Popconfirm,
    message
} from 'antd';
import { PlusCircleOutlined } from '@ant-design/icons';
import PageContainer from '@/components/BasePageContainer';
import { CM_Table_LoadTable } from '@/services/platform/bs'
import styles from './index.less'
const { Search } = Input;
const { Option } = Select;
const placeholder = "请输入表名"

const TableManager = () => {



    const columns = [
        {
            title: '名称',
            dataIndex: 'tableName',
            key: 'tableName',
            render: text => <a>{text}</a>,
        },
        {
            title: '别名',
            dataIndex: 'tableAlias',
            key: 'tableAlias',
        },
        {
            title: '表格样式',
            dataIndex: 'tableStyle',
            key: 'tableStyle',
        },
        {
            title: '模板',
            dataIndex: 'officeTmpl',
            key: 'officeTmpl',
            render: text => {
                let dom = ReactHtmlParser(text)
                return(<div>{dom}</div>)
            }
        },
        {
            title: '字段数量',
            dataIndex: 'fieldCount',
            key: 'fieldCount',
        },
        {
            title: '缺少字段',
            dataIndex: 'missingFieldCount',
            key: 'missingFieldCount',
            render: text => {
                let dom = ReactHtmlParser(text)
                return(<div>{dom}</div>)
            }
        },
        {
            title: '重复配置',
            dataIndex: 'repeatFieldCount',
            key: 'repeatFieldCount',
            render: text => {
                let dom = ReactHtmlParser(text)
                return(<div>{dom}</div>)
            }
        },
        {
            title: '未附加',
            dataIndex: 'extraFieldCount',
            key: 'extraFieldCount',
        },
        {
            title: '分组数量',
            dataIndex: 'groupCount',
            key: 'groupCount',
        },
        {
            title: '触发字段',
            dataIndex: 'exceptionFields',
            key: 'exceptionFields',
        },
        {
            title: '触发事件',
            dataIndex: 'exceptionEvents',
            key: 'exceptionEvents',
        },
        {
            title: '接口',
            dataIndex: 'interfaceText',
            key: 'interfaceText',
        },
        {
            title: '操作',
            dataIndex: 'action',
            key: 'action',
            width: 250,
            ellipsis: true,
            render: (text, record) => (
                <Space>
                    <Button
                        type="primary"
                        size="small"
                        onClick={() => {
                            changeDesc(record);
                        }}
                    >
                        修改
                </Button>
                    <Button
                        type="primary"
                        size="small"
                        onClick={() => {
                            changeDesc(record);
                        }}
                    >
                        编辑字段
                </Button>
                    <div onClick={e => e.stopPropagation()}>
                        <Popconfirm
                            title="是否删除该表？"
                            okText="确认"
                            cancelText="取消"
                            onConfirm={() => {
                                changeDesc(record);
                            }}
                        >
                            <Button size="small" danger>
                                删除
                    </Button>
                        </Popconfirm>
                    </div>
                </Space>
            ),
        },

    ];
    const [tableData, setTableData] = useState([])

    useEffect(() => {
        loadTable()
        
    }, [])
    const changeDesc = () => {

    }

    const AddTable = () => {

    }
    const handleSearch = (text) => {
        loadTable(text)
    }
    const loadTable = (keyword)=>{
        CM_Table_LoadTable({
            _version: 9999,
            filter:keyword
        }).then(
            res => {
                if (res.success == true) {
                    setTableData(res.root)
                }
            }
        )
    }
    return (
        <PageContainer>
            <div className={styles.tablemanager_container}>
                <div className={styles.operate_bar}>
                    <div className={styles.fast_search}>
                        <div className={styles.title}>快速检索</div>
                        <Search
                            allowClear
                            placeholder={placeholder}
                            onSearch={handleSearch}
                            // onChange={handleChange}
                            enterButton
                            style={{ width: "300px" }}
                        />
                    </div>

                    <Button type="primary" style={{ marginLeft: "10px" }} onClick={AddTable}>建表</Button>
                    <Button type="primary" style={{ marginLeft: "10px" }} onClick={AddTable}>附加</Button>

                </div>
                <div className={styles.table_container}>
                    <Table
                        columns={columns}
                        dataSource={tableData}
                        pagination={{pageSize:20}}
                        scroll={{ y: 700 }}
                        size="small"
                    />
                </div>
            </div>
        </PageContainer>
    )

}
export default TableManager;